import { Collection } from 'discord.js';
import Connection, { Endpoint } from './Connection';
export declare type YAMLConnections = {
    [name: string]: Endpoint[] | string;
};
export default class ConnectionsManager {
    list: Collection<string, Connection>;
    disabled: Collection<string, Connection | string>;
    constructor();
    load(): Promise<void>;
    static validateEndpoints(endpoints: Endpoint[]): Promise<Endpoint[]>;
    static createAutomaticDiscordChannel(threadID: string, name: string): Promise<Connection>;
    getWithCreateFallback(threadID: string, name: string): Promise<void | Connection>;
    getWith(id: string): Connection;
    get(name: string): Connection | undefined;
    has(id: string): boolean;
    save(): Promise<void>;
}
