"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = __importDefault(require("fs-extra"));
const FileConfig_1 = __importDefault(require("../config/FileConfig"));
const path_1 = __importDefault(require("path"));
exports.default = async (app) => {
    app.get('/logs', async (request, reply) => {
        if (!(config instanceof FileConfig_1.default))
            return reply.send([]);
        const count = request.query.count || 100;
        const logsFolderPath = path_1.default.join(path_1.default.parse(config.path).dir, 'logs');
        const logs = await fs_extra_1.default.readdir(logsFolderPath);
        const file = await fs_extra_1.default.readFile(path_1.default.join(logsFolderPath, logs.slice(-1)[0]), 'utf8');
        const lines = file.split('\n');
        return lines.slice(-count);
    });
    app.get('/status', (request, reply) => {
        reply.send({ status: config.paused ? 'paused' : 'running' });
    });
    app.post('/pause', (request, reply) => {
        config.paused = true;
        reply.send({ status: 'paused' });
    });
    app.post('/unpause', (request, reply) => {
        config.paused = false;
        reply.send({ status: 'running' });
    });
    app.post('/restart', async (request, reply) => {
        reply.send({});
        await discord.client.destroy();
        logger.success('Logged out from Discord');
        console.error('close 2');
    });
    app.post('/quit', async (request, reply) => {
        reply.send({});
        await discord.client.destroy();
        logger.success('Logged out from Discord');
        console.error('close 0');
    });
};
