"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Sentry = __importStar(require("@sentry/node"));
const os_1 = require("os");
const bannedErrors = [
    'Token/username/password not found.',
    'Missing Permissions',
    'Missing Access',
    'Incorrect login details were provided.',
    'Invalid username or email address',
    'Invalid username or password',
    'User must verify their account',
    'Service temporarily unavailable',
    'ECONNRESET',
    'MQTT connection failed',
    'EPIPE' // Facebook session invalidated
];
function sendToSentry(error) {
    if (bannedErrors.some(banned => error.toString().includes(banned) || error.message.includes(banned)))
        return;
    Sentry.captureException(error);
}
exports.sendToSentry = sendToSentry;
function initSentry() {
    const pkg = require('../../package.json');
    Sentry.init({
        dsn: 'https://a24e24e8c74f496db5fce2d611e085ee@sentry.miscord.net/2',
        maxBreadcrumbs: 0,
        release: `miscord@${pkg.version}`
    });
    Sentry.configureScope(scope => {
        scope.setTag('is_packaged', Boolean(process.pkg).toString().toLowerCase());
        scope.setTag('platform', os_1.platform());
        scope.setTag('version', pkg.version);
        scope.setTag('node_version', process.version);
    });
}
exports.initSentry = initSentry;
function closeSentry() {
    return Sentry.getCurrentHub().getClient().close(2000);
}
exports.closeSentry = closeSentry;
