"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const log = logger.withScope('messenger:cleanTemporaryFiles');
const fs_extra_1 = __importDefault(require("fs-extra"));
async function cleanTemporaryFiles({ attachments }) {
    if (attachments && attachments.length) {
        await Promise.all(attachments.map(attachment => fs_extra_1.default.unlink(attachment.filePath)));
        log.debug('Removed temporary attachment files');
    }
}
exports.default = cleanTemporaryFiles;
