"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const log = logger.withScope('messenger:sendMessage');
const getThread_1 = __importDefault(require("./getThread"));
const handleMentions_1 = __importDefault(require("./handleMentions"));
async function sendMessage(thread, { body, attachments }) {
    // handle mentions
    const mentions = handleMentions_1.default(body, await getThread_1.default(thread.id));
    if (body && body.trim()) {
        log.debug('Sending Messenger message');
        const info = await messenger.client.sendMessage(thread.id, body, { mentions });
        log.trace('sent message info', info);
        log.debug('Sent message on Messenger');
    }
    if (attachments && attachments.length) {
        log.debug('Sending Messenger attachments');
        const info = await Promise.all(attachments.map(attachment => messenger.client.sendAttachmentFile(thread.id, attachment.filePath, attachment.extension)));
        log.trace('sent attachments info', info);
        log.debug('Sent Messenger attachments');
    }
}
exports.default = sendMessage;
